import javax.naming.Context;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.DirContext;
import javax.naming.directory.Attributes;
import javax.naming.NamingException;
import java.util.Hashtable;

/**
 * Demonstrates how to retrieve an attribute of a named object.
 *
 * usage: java Getattr
 */
class Getattr {
    public static void main(String[] args) {
	// Identify service provider to use
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {

	    // Create the initial directory context
	    DirContext ctx = new InitialDirContext(env);
	    
	    // Ask for all attributes of object 
	    Attributes attrs = ctx.getAttributes("cn=Ted Geisel, ou=People");

	    // Find the surname ("sn") and print it out
	    System.out.println("sn: " + attrs.get("sn").get());

	} catch (NamingException e) {
	    System.err.println("Problem getting attribute: " + e);
	}
    }
}
